
#include "common.h"
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <netdb.h>
#include <pwd.h>
extern h_errno;
extern char logbuf[];
extern int bnclog (confetti * jr, char *logbuff);


#define ENDLESSLOOP for(;;)

int highfd;
int a_sock = 0;
int s_sock = 0;
struct sockaddr_in muhsin;
struct sockaddr wipi;
int sinlen;

int allbuflen;
unsigned char allbuf[1024];
unsigned char linbuff[1024];
int bufs;
unsigned char buffer[1024];

unsigned char motdb[514];
confetti *jack;
struct vhostentry *hockum;

char *commands[] =
{
  "NICK", "PASS", "USER", "MAIN",
  "VIP", "CONN", "BWHO", "BKILL",
  "VDF", "VN", "DIE", "ADDHOST",
  "LISTHOST", "BDIE", "HELP", "IDENT", NULL
};

#define NICK 0
#define PASS 1
#define USER 2
#define MAIN 3
#define VIP 4
#define CONN 5
#define BWHO 6
#define BKILL 7
#define VDF 8
#define VN 9
#define DIE 10
#define ADDHOST 11
#define LISTHOST 12
#define BDIE 13			/* hehe unlucky 13? */
#define BHELP 14
#define BIDENT 15




char *helplist[] =
{
  "COMMANDS are /quote:",
  "MAIN <Supervisor password>",
  "VIP [new virtual host]",
  "IDENT <newident>",
  "CONN <server address> [port] [pass]",
  "VDF", "VN", "ADDHOST", "LISTHOST",
  "-----ADMIN COMMANDS----",
  "BWHO",
  "BKILL <FD>",
  "DIE",
  "BDIE",
  "For a detailed explanation of commands, consult the file README",
  NULL
};






int passwordokay (char *, char *);
int connokay (struct sockaddr_in, confetti *);
int match (char *, char *);
extern void add_access (confetti *, accesslist *);

struct uconentry
{
  struct uconentry *next;
  char user[256];
  char nick[256];
  char vhost[256];
  char fromip[256];
  char uname[11];
  unsigned int
    u:1, p:1, n:1, s:1, b:1, a:1;
  int fd;
  int pfails;
  fifobuffer biff;
  int sargc;
  char *sargv[5];
  char sargb[1024];


};

struct conentry
{
  struct conentry *next;
  char nick[256];
  char fromip[256];
  char onserver[256];
  int ifd;
  int ofd;
};

struct uconentry headucon;
struct conentry headcon;

#ifndef HAVE_SNPRINTF
char mybuf[4096];		/* dumb but oh well, attempting securety : */

int snprintf (char *str, size_t n, const char *format,...)
{
  int p;
  va_list ap;

  va_start (ap, format);
  p = vsprintf (mybuf, format, ap);
  va_end (ap);
  strncpy (str, mybuf, n);
  if (p > n)
  {
    p = strlen (str);
  }
  return p;
}
#endif



int freecon (struct conentry *list_ptr)
{
  struct conentry *hold_ptr;

  while (list_ptr != NULL)
  {
    hold_ptr = list_ptr->next;
    close (list_ptr->ofd);
    close (list_ptr->ifd);
    free (list_ptr);
    list_ptr = hold_ptr;
  }
  return 1;

}
int freeucon (struct uconentry *list_ptr)
{
  struct uconentry *hold_ptr;

  while (list_ptr != NULL)
  {
    hold_ptr = list_ptr->next;
    close (list_ptr->fd);
    free (list_ptr);
    list_ptr = hold_ptr;
  }
  return 1;

}



int bewmstick (void)
{
  int p, f;

  freeucon (headucon.next);
  freecon (headcon.next);
  headucon.next = NULL;
  headcon.next = NULL;
}


struct uconentry *adducon (struct uconentry *list_ptr)
{
  while (list_ptr->next != NULL)
    list_ptr = list_ptr->next;
  list_ptr->next = (struct uconentry *) malloc (sizeof (struct uconentry));

  if (list_ptr->next != NULL)
  {
    memset (list_ptr->next, 0, sizeof (struct uconentry));

    (list_ptr->next)->next = (struct uconentry *) NULL;
  }
  return (list_ptr->next);
}

struct conentry *addcon (struct conentry *list_ptr)
{
  while (list_ptr->next != NULL)
    list_ptr = list_ptr->next;
  list_ptr->next = (struct conentry *) malloc (sizeof (struct conentry));

  if (list_ptr->next != NULL)
  {
    memset (list_ptr->next, 0, sizeof (struct conentry));

    (list_ptr->next)->next = (struct conentry *) NULL;
  }
  return (list_ptr->next);
}


struct uconentry *delucon (struct uconentry *list_ptr, int nfd)
{
  struct uconentry *last_ptr;

  last_ptr = list_ptr;
  while ((list_ptr->fd != nfd))
  {
    last_ptr = list_ptr;
    if ((list_ptr = list_ptr->next) == NULL)
      break;

  }
  if (list_ptr != NULL)
  {
    last_ptr->next = list_ptr->next;
    free (list_ptr);
  }
  return list_ptr;
}

struct conentry *delcon (struct conentry *list_ptr, int nfd)
{
  struct conentry *last_ptr;

  last_ptr = list_ptr;
  while ((list_ptr->ifd != nfd))
  {
    if ((list_ptr->ofd == nfd))
      break;
    last_ptr = list_ptr;
    if ((list_ptr = list_ptr->next) == NULL)
      break;

  }
  if (list_ptr != NULL)
  {
    last_ptr->next = list_ptr->next;
    free (list_ptr);
  }
  return list_ptr;
}

int getother (struct conentry *list_ptr, int nfd)
{
  while (list_ptr != NULL)
  {
    if (list_ptr->ofd == nfd)
      return list_ptr->ifd;
    else if (list_ptr->ifd == nfd)
      return list_ptr->ofd;
    list_ptr = list_ptr->next;
  }
  return -1;

}

struct conentry *getcon (struct conentry *list_ptr, int nfd)
{
  while (list_ptr != NULL)
  {
    if (list_ptr->ofd == nfd)
      return list_ptr;
    else if (list_ptr->ifd == nfd)
      return list_ptr;
    list_ptr = list_ptr->next;
  }
  return NULL;

}

int countfds (struct uconentry *uclist_ptr, struct conentry *clist_ptr)
{
  int p;

  p = 0;
  while (uclist_ptr != NULL)
  {
    uclist_ptr = uclist_ptr->next;
    p++;
  }
  while (clist_ptr != NULL)
  {
    clist_ptr = clist_ptr->next;
    p++;
  }
  return p;

}

char *gethost (addr)
     struct in_addr *addr;
{
  struct hostent *hp;

  hp = gethostbyaddr ((char *) addr, sizeof (struct in_addr), AF_INET);

  if (hp)
    return hp->h_name;
  else
    return inet_ntoa (*addr);
}

int remnl (char *buf, int size)
{
  int p;

  for (p = 0; p < size; p++)
  {
    if (buf[p] == '\n')
    {
      buf[p] = '\0';
      return p;
    }
  }
  return p;
}

int do_connect (char *vhostname, char *hostname, u_short port, char *uname)
{
  int s;
  int f;
  struct hostent *he;
  struct sockaddr_in sin;

  f = 1;
  s = socket (AF_INET, SOCK_STREAM, 0);
  if (s < 0)
    return -2;
  memset (&sin, 0, sizeof (struct sockaddr_in));

  sin.sin_family = AF_INET;

  if (vhostname == NULL)
    f = 0;
  else if (strlen (vhostname) < 1)
    f = 0;

  sin.sin_addr.s_addr = (f ? inet_addr (vhostname) : INADDR_ANY);
  if ((sin.sin_addr.s_addr == -1) && f)
  {
    he = gethostbyname (vhostname);
    if (he)
    {
      memcpy (&sin.sin_addr, he->h_addr, he->h_length);
    }
    else
    {
      sin.sin_addr.s_addr = INADDR_ANY;
    }
  }

  if (bind (s, (struct sockaddr *) &sin, sizeof (struct sockaddr_in)) < 0)
  {
    return -9;
  }
  memset (&sin, 0, sizeof (struct sockaddr_in));

  sin.sin_family = AF_INET;
  sin.sin_port = htons (port);
  sin.sin_addr.s_addr = inet_addr (hostname);
  if (sin.sin_addr.s_addr == -1)
  {
    he = gethostbyname (hostname);
    if (!he)
      return -1;
    memcpy (&sin.sin_addr, he->h_addr, he->h_length);
  }
  if (jack->identwd)
  {
    FILE *fp = NULL;
    struct passwd *pw = getpwuid (getuid ());
    char filename[1024];

    sprintf (filename, "%s/.identwd/%s.%i.LOCK",
	     pw->pw_dir, inet_ntoa (sin.sin_addr),
	     port);
    fp = fopen (filename, "w");
    if (fp)
    {
      fprintf (fp, "WAIT\n");
      fclose (fp);
    }
  }

  if (connect (s, (struct sockaddr *) &sin, sizeof (sin)) < 0)
  {
    close (s);
    return -2;
  }
  if (jack->identwd)
  {
    FILE *fp = NULL;
    struct passwd *pw = getpwuid (getuid ());
    char filename[1024];

    sprintf (filename, "%s/.identwd/%s.%i.LOCK",
	     pw->pw_dir, inet_ntoa (sin.sin_addr),
	     port);
    fp = fopen (filename, "w");
    if (fp)
    {
      int len = sizeof (struct sockaddr_in);
      struct sockaddr_in mysa;

      getsockname (s, (struct sockaddr *) &mysa, &len);
      fprintf (fp, (char *) "%s %i %s\n",
	       (char *) inet_ntoa (mysa.sin_addr),
	       (u_short) ntohs (mysa.sin_port),
	       uname);
      fclose (fp);
    }
  }
  return s;
}


int handlepucon (struct uconentry *list_ptr, int pargc, char **pargv)
{
  int p, c, f;
  struct conentry *bob;
  struct hostent *he;
  struct in_addr addr;
  char *tmp;
  char *pasb;
  int cs, cport;

  p = 0;
  while (commands[p] != NULL)
  {
    if (!strncasecmp (pargv[0], commands[p], strlen (pargv[0])))
      break;
    p++;
  }
  if (commands[p] != NULL)
  {
    switch (p)
    {
      case NICK:
	{
	  if (pargc < 2)
	    break;
	  strncpy (list_ptr->nick, pargv[1], 256);
	  list_ptr->n = 1;
	  if (list_ptr->p == 0)
	  {
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :You need to say /quote PASS <password>\n", list_ptr->nick);
	    send (list_ptr->fd, buffer, bufs, 0);
	  }

	  break;
	}
      case PASS:
	{
	  if (pargc < 2)
	    return 0;
	  if (list_ptr->p)
	    break;
	  strcpy (list_ptr->sargb, "CONN:");
	  strncat (list_ptr->sargb, pargv[1], 1024);
/* new stuff */
	  p = 0;
	  tmp = strtok (list_ptr->sargb, ":");
	  list_ptr->sargv[p++] = tmp;
	  while ((tmp = strtok (NULL, ":")) != NULL)
	  {
	    list_ptr->sargv[p++] = tmp;
	    if (p > 5)
	      break;
	  }
	  list_ptr->sargc = p;
/* end of crap */
	  pasb = list_ptr->sargv[1];
	  for (p = 2; p < list_ptr->sargc; p++)
	  {
	    list_ptr->sargv[p - 1] = list_ptr->sargv[p];
	  }
	  list_ptr->sargc--;
	  if (passwordokay (pasb, jack->dpass))
	  {
	    list_ptr->p = 1;
	    if (list_ptr->n)
	    {
	      FILE *motdf;

	      bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Welcome to BNC " VERSION ", the irc proxy\n", list_ptr->nick);
	      send (list_ptr->fd, buffer, bufs, 0);
	      if ((motdf = fopen (jack->motdf, "r")) != NULL)
	      {
		while (!feof (motdf))
		{
		  fgets (motdb, 512, motdf);
		  remnl (motdb, 512);
		  motdb[513] = '\0';
		  bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :-*- %s\n", list_ptr->nick, motdb);
		  send (list_ptr->fd, buffer, bufs, 0);
		}
		fclose (motdf);
	      }

	    }
	    if (list_ptr->sargc > 2)
	      list_ptr->a = 1;
	    break;
	  }
	  list_ptr->pfails++;
	  if (list_ptr->pfails > 2)
	  {
	    close (list_ptr->fd);
	    delucon (&headucon, list_ptr->fd);
	    return 100;
	  }
	  snprintf (logbuf, 1024, "Failed pass from %s password %s", list_ptr->fromip, pasb);
	  bnclog (jack, logbuf);
	  if (list_ptr->n)
	  {
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Failed Pass!!\n", list_ptr->nick);
	    send (list_ptr->fd, buffer, bufs, 0);
	  }
	  break;
	}
      case USER:
	{

	  if (pargc < 5)
	    return 0;

	  c = pargc - 4;
	  strncpy (list_ptr->user, pargv[1], 256);
	  strncat (list_ptr->user, " ", 256);
	  strncat (list_ptr->user, pargv[2], 256);
	  strncat (list_ptr->user, " ", 256);
	  strncat (list_ptr->user, pargv[3], 256);
	  strncpy (list_ptr->uname, pargv[1], 10);
	  for (f = 0; f < c; f++)
	  {
	    strncat (list_ptr->user, " ", 256);
	    strncat (list_ptr->user, pargv[4 + f], 256);
	  }
	  list_ptr->u = 1;
	  break;
	}
      case BHELP:
	{
	  if (list_ptr->b == 0)
	    return 0;
	  for (p = 0; helplist[p] != NULL; p++)
	  {
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :*** %s\n", list_ptr->nick, helplist[p]);
	    send (list_ptr->fd, buffer, bufs, 0);
	  }
	  break;
	}
      case BIDENT:
	{
	  if (list_ptr->b == 0)
	    break;
	  if (pargc < 2)
	  {
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :current ident is %s\n", list_ptr->nick, list_ptr->uname);
	    send (list_ptr->fd, buffer, bufs, 0);
	    break;
	  }
	  bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :changing ident from %s to %s\n", list_ptr->nick, list_ptr->uname, pargv[1]);
	  send (list_ptr->fd, buffer, bufs, 0);
	  strncpy (list_ptr->uname, pargv[1], 10);
	  break;
	}
      case MAIN:
	{

	  if (list_ptr->b == 0)
	    return 0;
	  if (pargc < 2)
	    return 0;
	  if (passwordokay (pargv[1], jack->spass))
	  {
	    list_ptr->s = 1;
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Welcome Supervisor!!\n", list_ptr->nick);
	    send (list_ptr->fd, buffer, bufs, 0);
	    break;
	  }
	  snprintf (logbuf, 1024, "Failed MAIN from %s", list_ptr->fromip);
	  bnclog (jack, logbuf);
	  bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Failed Main!!\n", list_ptr->nick);
	  send (list_ptr->fd, buffer, bufs, 0);

	  break;
	}
      case VN:
	{
	  bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Nulling out Vhost to system internal default\n", list_ptr->nick);
	  send (list_ptr->fd, buffer, bufs, 0);
	  memset (list_ptr->vhost, '\0', 256);
	  break;
	}
      case VDF:
	{
	  if (strlen (jack->vhostdefault) < 1)
	  {
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Switching Vhost back to default\n", list_ptr->nick);
	  }
	  else
	  {
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Switching Vhost back to default (%s)\n", list_ptr->nick, jack->vhostdefault);
	  }
	  send (list_ptr->fd, buffer, bufs, 0);
	  strncpy (list_ptr->vhost, jack->vhostdefault, 256);
	  break;
	}
      case VIP:
	{
	  if (list_ptr->b == 0)
	    return 0;
	  f = 0;
	  if (pargc > 1)
	  {

	    he = gethostbyname (pargv[1]);
	    if (he)
	    {
	      memcpy (&addr.s_addr, he->h_addr, sizeof (addr.s_addr));
	      bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Switching Vhost to %s (%s)\n", list_ptr->nick, pargv[1], inet_ntoa (addr));
	      send (list_ptr->fd, buffer, bufs, 0);
	      strncpy (list_ptr->vhost, pargv[1], 256);
	    }
	    else
	    {
	      bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Vhost %s invalid\n", list_ptr->nick, pargv[1]);
	      send (list_ptr->fd, buffer, bufs, 0);

	    }


	  }
	  else
	  {

	    if (jack->vhostf)
	    {
	      hockum = &jack->vhostlist;
	      bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Listing Vhosts\n", list_ptr->nick);
	      send (list_ptr->fd, buffer, bufs, 0);
	      if (strlen (list_ptr->vhost) != 0)
	      {
		bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Default Vhost: %s\n", list_ptr->nick, list_ptr->vhost);
	      }
	      else
	      {
		bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Default Vhost: -SYSTEM DEFAULT-\n", list_ptr->nick);
	      }
	      send (list_ptr->fd, buffer, bufs, 0);
	      while (hockum != NULL)
	      {
		bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s : (%i) %s\n", list_ptr->nick, f, hockum->vhost);
		send (list_ptr->fd, buffer, bufs, 0);
		f++;
		hockum = hockum->next;
	      }
	    }
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :End of Vhost list\n", list_ptr->nick);
	    send (list_ptr->fd, buffer, bufs, 0);
	  }
	  break;
	}
      case CONN:
	{
	  if (list_ptr->b == 0)
	    return 0;
	  if (list_ptr->a)
	  {
	    list_ptr->a = 0;
	    list_ptr->b = 0;

	  }

	  if (pargc < 2)
	    break;
	  if (pargc > 2)
	    cport = atoi (pargv[2]);
	  else
	    cport = jack->cport;
	  bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Making reality through %s port %i\n", list_ptr->nick, pargv[1], cport);
	  send (list_ptr->fd, buffer, bufs, 0);
	  cs = do_connect (list_ptr->vhost, pargv[1], cport, list_ptr->uname);
	  if (cs > 0)
	  {
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Suceeded connection\n", list_ptr->nick);
	    bnclog (jack, logbuf);

	    send (list_ptr->fd, buffer, bufs, 0);
	    if (pargc > 3)
	    {
	      bufs = snprintf (buffer, 1024, "PASS :%s\n", pargv[3]);
	      send (cs, buffer, strlen (buffer), 0);
	    }
	    bufs = snprintf (buffer, 1024, "NICK %s\n", list_ptr->nick);
	    send (cs, buffer, strlen (buffer), 0);
	    bufs = snprintf (buffer, 1024, "USER %s\n", list_ptr->user);
	    send (cs, buffer, strlen (buffer), 0);
	    if ((bob = addcon (&headcon)) == NULL)
	    {
	      close (cs);
	      close (list_ptr->fd);
	      break;
	    }
	    bob->ifd = list_ptr->fd;
	    bob->ofd = cs;
	    strncpy (bob->nick, list_ptr->nick, 256);
	    strncpy (bob->fromip, list_ptr->fromip, 256);
	    strncpy (bob->onserver, pargv[1], 256);
	    delucon (&headucon, list_ptr->fd);
	    return 100;

	  }
	  else
	  {
	    if (cs == -9)
	    {
	      bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Failed Connection (Supplied Vhost is not on this system)\n", list_ptr->nick);
	    }
	    else
	    {
	      bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Failed Connection\n", list_ptr->nick);
	    }
	    send (list_ptr->fd, buffer, bufs, 0);
	  }
	  break;
	}
      case BWHO:
	{
	  if (list_ptr->s == 0)
	    return 0;
	  bob = headcon.next;
	  while (bob != NULL)
	  {
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :(FD %i)[%s@%s] on server %s\n", list_ptr->nick, bob->ifd, bob->nick, bob->fromip, bob->onserver);
	    send (list_ptr->fd, buffer, bufs, 0);
	    bob = bob->next;
	  }
	  break;
	}
      case DIE:
	{
	  if (list_ptr->s == 0)
	    return 0;
	  bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Shutting it down....\n", list_ptr->nick);
	  send (list_ptr->fd, buffer, bufs, 0);
	  bewmstick ();
	  break;

	}
      case BKILL:
	{
	  if (list_ptr->s == 0)
	    return 0;
	  if (pargc < 2)
	    return 0;
	  p = atoi (pargv[1]);
	  f = getother (headcon.next, p);
	  if (f == -1)
	  {
	    bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :No such FD %i\n", list_ptr->nick, p);
	    send (list_ptr->fd, buffer, bufs, 0);
	    return 0;
	  }
	  bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Killed %i\n", list_ptr->nick, p);
	  send (list_ptr->fd, buffer, bufs, 0);
	  bob = getcon (headcon.next, p);

	  snprintf (logbuf, 1024, "BKILL to %s@%s", bob->nick, bob->fromip);
	  bnclog (jack, logbuf);


	  close (p);
	  close (f);
	  delcon (&headcon, p);
	  break;
	}
      case ADDHOST:
	{
	  accesslist *na;

	  if (list_ptr->s == 0)
	    return 0;
	  if (pargc < 3)
	    return 0;
	  if (atoi (pargv[1]) > 2)
	    return 0;
	  na = malloc (sizeof (accesslist));
	  na->type = atoi (pargv[1]);
	  strncpy (na->addr, pargv[2], 63);
	  na->next = NULL;
	  add_access (jack, na);
	  snprintf (logbuf, 1024, "ADDHOST %s", pargv[2]);
	  bnclog (jack, logbuf);
	  break;
	}
      case LISTHOST:
	{
	  accesslist *na;
	  int i;

	  if (list_ptr->s == 0)
	    return 0;
	  for (na = jack->alist, i = 1; na; na = na->next, i++)
	  {
	    sprintf (buffer, ":Bnc!system@bnc.com NOTICE %s :#%i: (t:%i) %s\r\n", list_ptr->nick, i, (int) na->type, na->addr);
	    send (list_ptr->fd, buffer, strlen (buffer), 0);
	  }
	  break;
	}
      case BDIE:
	{
	  if (list_ptr->s)
	    bnckill (FATALITY);
	  break;
	}
    }

    if (list_ptr->n == 0)
      return 0;
    if (list_ptr->u == 0)
      return 0;
    if (list_ptr->p == 0)
      return 0;

    if (list_ptr->b == 0)
    {
      list_ptr->b = 1;
      if (list_ptr->a)
      {
	return handlepucon (list_ptr, list_ptr->sargc, list_ptr->sargv);
      }
      bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :Level two, lets connect to something real now\n", list_ptr->nick);
      send (list_ptr->fd, buffer, bufs, 0);
      bufs = snprintf (buffer, 1024, ":Bnc!system@bnc.com NOTICE %s :type /quote conn [server] <port> <pass> to connect\n", list_ptr->nick);
      send (list_ptr->fd, buffer, bufs, 0);
    }

  }
  return 0;
}

int handleucon (struct uconentry *list_ptr, int buflen, char *buf)
{
  int p, f;
  char *pargv[100];
  char *tmp;

  p = 0;
  tmp = strtok (linbuff, " \n\r");
  if (tmp != NULL)
  {
    pargv[p++] = tmp;
    while ((tmp = strtok (NULL, " \n\r")) != NULL)
    {
      pargv[p++] = tmp;
      if (p > 100)
	break;
    }
    f = handlepucon (list_ptr, p, pargv);
    if (f == 100)
      return 100;
  }

  return 0;

}



int setucon (struct uconentry *list_ptr, fd_set * nation)
{
  while (list_ptr != NULL)
  {
    FD_SET (list_ptr->fd, nation);
    if (list_ptr->fd > highfd)
      highfd = list_ptr->fd;
    list_ptr = list_ptr->next;
  }
}

int setcon (struct conentry *list_ptr, fd_set * nation)
{
  while (list_ptr != NULL)
  {
    FD_SET (list_ptr->ifd, nation);
    if (list_ptr->ifd > highfd)
      highfd = list_ptr->ifd;
    FD_SET (list_ptr->ofd, nation);
    if (list_ptr->ofd > highfd)
      highfd = list_ptr->ofd;
    list_ptr = list_ptr->next;
  }
}

void initucon (fd_set * nation)
{
  highfd = s_sock;
  FD_ZERO (nation);
  FD_SET (s_sock, nation);
  setucon (headucon.next, nation);
}


void initcon (fd_set * nation)
{
  setcon (headcon.next, nation);
}

int chkucon (struct uconentry *list_ptr, fd_set * nation)
{
  int p, c, f;

  while (list_ptr != NULL)
  {
    if (FD_ISSET (list_ptr->fd, nation))
    {
      allbuflen = recv (list_ptr->fd, allbuf, 1024, 0);
      if (allbuflen <= 0)
      {
	return list_ptr->fd;
      }
      for (p = 0; p < allbuflen; p++)
      {
	if ((pushchar_fifo (&list_ptr->biff, allbuf[p])) == -1)
	{
	  return list_ptr->fd;
	}
	if ((allbuf[p] == '\n') || (allbuf[p] == '\r') || (allbuf[p] == '\0'))
	{
	  memset (linbuff, 0, 1024);
	  c = popline_fifo (&list_ptr->biff, linbuff);
	  f = handleucon (list_ptr, c, linbuff);
	  if (f == 100)
	    return 0;

	}

      }
    }

    list_ptr = list_ptr->next;
  }
  return 0;
}


int chkcon (struct conentry *list_ptr, fd_set * nation)
{
  int p, c, f;

  while (list_ptr != NULL)
  {
    if (FD_ISSET (list_ptr->ifd, nation))
    {
      allbuflen = recv (list_ptr->ifd, allbuf, 1024, 0);
      if (allbuflen <= 0)
      {
	return list_ptr->ifd;
      }
      send (list_ptr->ofd, allbuf, allbuflen, 0);
    }
    if (FD_ISSET (list_ptr->ofd, nation))
    {
      allbuflen = recv (list_ptr->ofd, allbuf, 1024, 0);
      if (allbuflen <= 0)
      {
	return list_ptr->ofd;
      }
      send (list_ptr->ifd, allbuf, allbuflen, 0);
    }

    list_ptr = list_ptr->next;
  }
  return 0;
}

void docon (fd_set * nation)
{
  int p, f;
  struct conentry *bob;

  if (p = chkcon (headcon.next, nation))
  {
    f = getother (headcon.next, p);
    bob = getcon (headcon.next, p);
    snprintf (logbuf, 1024, "connection closed on %s@%s", bob->nick, bob->fromip);
    bnclog (jack, logbuf);
    close (p);
    close (f);
    delcon (&headcon, p);
  }

}

void doucon (fd_set * nation)
{
  int citizen, p;
  struct in_addr faddr;

  struct uconentry *bob;

  if (FD_ISSET (s_sock, nation))
  {
    citizen = accept (s_sock, (struct sockaddr *) &muhsin, &sinlen);

    if (citizen >= 0)
    {


      if (jack->maxusers)
      {
	if (countfds (headucon.next, headcon.next) + 1 > jack->maxusers)
	{
	  close (citizen);
	  return;

	}
      }
      p = sizeof (muhsin);
      getpeername (citizen, (struct sockaddr *) &muhsin, &p);
      if (!connokay (muhsin, jack))
      {
	close (citizen);
	return;
      }
      if ((bob = adducon (&headucon)) == NULL)
      {
	close (citizen);
      }
      strncpy (bob->vhost, jack->vhostdefault, 256);


      faddr = muhsin.sin_addr;
      strncpy (bob->fromip, gethost (&faddr), 256);


      bob->fd = citizen;
      if (jack->dpassf == 0)
      {
	bob->p = 1;
      }
      zero_fifo (&bob->biff);
    }
  }
  /* normal connection stuff */
  if (p = chkucon (headucon.next, nation))
  {
    close (p);
    delucon (&headucon, p);
  }

}

int initproxy (confetti * jr)
{
  int f;

  s_sock = socket (AF_INET, SOCK_STREAM, 0);
  if (s_sock < 0)
  {
    return SOCKERR;
  }
  memset (&muhsin, 0, sizeof (struct sockaddr_in));

  muhsin.sin_family = AF_INET;
  muhsin.sin_port = htons (jr->dport);
  muhsin.sin_addr.s_addr = INADDR_ANY;
  f = 1;
  setsockopt (s_sock, SOL_SOCKET, SO_REUSEADDR, &f, sizeof (f));

  if (bind (s_sock, (struct sockaddr *) &muhsin, sizeof (struct sockaddr_in)) < 0)
  {
    close (s_sock);
    return BINDERR;
  }
  if (listen (s_sock, 10) < 0)
  {
    return LISTENERR;
  }
  return 0;
}

int ircproxy (confetti * jr)
{
  int p;
  fd_set nation;

  jack = jr;
  ENDLESSLOOP
  {
    initucon (&nation);
    initcon (&nation);
    if ((p = select (highfd + 1, &nation, (fd_set *) 0, (fd_set *) 0, NULL)) < 0)
    {

      bnckill (SELECTERR);
    }
    docon (&nation);
    doucon (&nation);
  }
  return 0;
}

int passwordokay (char *s, char *pass)
{

  char *encr;
  char salt[3];
  char *crypt ();

  if (pass[0] == '+')
  {
    pass = &pass[1];

    salt[0] = pass[0];
    salt[1] = pass[1];
    salt[2] = 0;
    encr = crypt (s, salt);
  }
  else
  {
    encr = s;
  }

  if (!strncmp (encr, pass, 10))
    return 1;
  else
    return 0;
}

int connokay (struct sockaddr_in sa, confetti * jr)
{
  struct hostent *hp = gethostbyaddr ((char *) &sa.sin_addr, sizeof (sa.sin_addr), AF_INET);

  accesslist *na;

  snprintf (logbuf, 1024, "Connection from %s", inet_ntoa (sa.sin_addr));
  bnclog (jack, logbuf);

  if (!jr->has_alist)
    return 1;
  for (na = jr->alist; na; na = na->next)
  {
    if (na->type == 1)
    {
      if (!match (inet_ntoa (sa.sin_addr), na->addr))
	return 1;
    }
    else if (na->type == 2 && hp)
    {
      if (!match (hp->h_name, na->addr))
	return 1;
    }
  }
  return 0;
}

/*
 * experimental matching code (WD) I hope this runs faster, who knows...
 */

int check_match (char *mask)
{
  if (!index (mask, '*') && !index (mask, '?'))
    return 0;
  else if (!strcmp (mask, "*"))
    return 1;
  else
    return 2;
}

/*
 * Note, thanx to RogerY and Redtrio for this wonderful code.  Please
 * keep this notice intact.  -- TazQ 
 */

/*
 * My wildcard matching functions. I think it works well :) Seems to be 
 */
/*
 * working stablely, but not too sure.                                  
 */
int
  match (char *str, char *wld)
{
  int i = check_match (wld);

  switch (i)
  {
    case 0:
      return strcasecmp (str, wld);
      break;
    case 1:
      return 0;
      break;
  }

  if (!(*wld) || !(*str))
    return 1;
  while (*wld || *str)
  {
    if (tolower (*wld) == tolower (*str))
    {
      wld++;
      str++;
    }
    else if (tolower (*wld) != tolower (*str) && *wld == '*')
    {
      int i = 0;
      char *st;
      st = (char *) malloc (sizeof (char[strlen (wld) + 1]));

      while (*wld == '*' && *wld)
      {
	wld++;
	if (!*wld)
	  return 0;
      }
      while (*wld && *wld != '*' && *wld != '?')
      {
	st[i] = *wld;
	i++;
	wld++;
      }
      st[i] = '\0';
      while (*str && strncasecmp (st, str, strlen (st)))
	str++;
      if (!strncasecmp (st, str, strlen (st)))
	str += strlen (st);
      else
	return 1;
    }
    else if (tolower (*wld) != tolower (*str) && *wld == '?' && *wld && *str)
    {
      wld++;
      str++;
    }
    else if (tolower (*wld) != tolower (*str))
      return 1;
  }
  return 0;
}
